
# coding: utf-8

# In[1]:

import numpy as np
import pandas as pd
import random
import array
from sklearn.svm import LinearSVC
from sklearn.metrics import accuracy_score
from sklearn.model_selection import train_test_split
from sklearn.ensemble import RandomForestClassifier

# In[9]:

train = pd.read_csv('./train.tsv', sep='\t', header = None)
test = pd.read_csv('./test.tsv', sep='\t', header = None)


# In[17]:

train.head()


# In[18]:

test.head()


# In[13]:

train[2] = train[3].map(str) + train[2]
test[2] = test[3].map(str) + test[2]


# In[16]:

train = train.loc[:,[1,2]]
test = test.loc[:,[1,2]]


# In[24]:

from sklearn.feature_extraction.text import CountVectorizer
count_vect = CountVectorizer()


# In[30]:

train_counts = count_vect.fit_transform(train[2])
print('train_counts shape: ',train_counts.shape)


# In[28]:

test_counts = count_vect.transform(test[2])
print('train_counts shape: ',test_counts.shape)


# In[31]:

print('size after CountVectorizer', len(count_vect.vocabulary_))


# In[32]:

from sklearn.feature_extraction.text import TfidfTransformer
tfidf_transformer = TfidfTransformer()


# In[34]:

train_tfidf = tfidf_transformer.fit_transform(train_counts)
print('train shape after tfidf transform', train_tfidf.shape)


# In[35]:

test_tfidf = tfidf_transformer.transform(test_counts)
print('test shape after tfidf transform', test_tfidf.shape)


# In[37]:

from sklearn.decomposition import TruncatedSVD
lsa = TruncatedSVD(500)


# In[38]:

train_lsa = lsa.fit_transform(train_tfidf)
print('train shape after lsa transform', train_lsa.shape)


# In[39]:

test_lsa = lsa.fit_transform(test_tfidf)
print('test shape after lsa transform', test_lsa.shape)


# In[40]:

print('train_lsa is of type:',type(train_lsa))
print('test_lsa is of type:',type(test_lsa))

train_lsa = np.asarray(train_lsa).tolist()
test_lsa = np.asarray(test_lsa).tolist()

print('train_lsa is of type:',type(train_lsa))
print('test_lsa is of type:',type(test_lsa))

train_tfidf = train_tfidf.toarray()
test_tfidf = test_tfidf.toarray()




# In[41]:

def DotProduct(w,data):
    dp=0
    dp=sum(x*y for x,y in zip(w,data))
    return dp

def sign(x):
    if x > 0:
        return 1.
    elif x < 0:
        return -1.
    elif x == 0:
        return 0.
    else:
        return x


# In[42]:

X_train = train_tfidf
X_test = test_tfidf
y_train = train[1]
y_test = test[1]


# In[ ]:

labelsTrain = []
for i in range(0,len(y_train)):
    labelsTrain.append(y_train.iloc[i])

labelsTest = []
for i in range(0,len(y_test)):
    labelsTest.append(y_test.iloc[i])

print('For origignal data representation')
clf1 = LinearSVC()
clf1.fit(X_train, labelsTrain)
prediction1 = clf1.predict(X_test)

clf2 = RandomForestClassifier(n_estimators = 1000, random_state = 0)
clf2.fit(X_train, labelsTrain)
prediction2 = clf2.predict(X_test)

print('Accuracy Score for svm: ',accuracy_score(labelsTest,prediction1))
print('Accuracy Score for RandomForest: ',accuracy_score(labelsTest, prediction2))


kList = [100000]#[10,100,1000,10000,100000]
for number in kList:
    Z = []
    Zp = []
    for i in range(0,number):
        w = []
        z = []
        zp = []
        for k in range(0,len(X_train[0])):
            w.append(random.uniform(-1, 1))
        for j in range(0,len(X_train)):
            dp = DotProduct(X_train[j],w)
            val = (1+sign(dp))/2
            z.append(val)
        Z.append(z)
        for j in range(0,len(X_test)):
            dp = DotProduct(X_test[j],w)
            valt = (1+sign(dp))/2
            zp.append(valt)
        Zp.append(zp)


    Zt = []
    Zpt = []
    Zt = [[Z[j][i] for j in range(len(Z))] for i in range(len(Z[0]))]
    Zpt = [[Zp[j][i]for j in range(len(Zp))] for i in range(len(Zp[0]))]

    
    
    print('For transformed data representation')
    clf1 = LinearSVC()
    clf1.fit(Zt, labelsTrain)
    prediction1 = clf1.predict(Zpt)
    
    clf2 = RandomForest(n_estimators = 1000, random_state = 0)
    clf2.fit(Zt, labelsTrain)
    prediction2 = clf2.predict(Zpt)
    


    print('Accuracy Score for LinearSVC for K = ',number,'is:',accuracy_score(labelsTest,prediction1))
    print('Accuracy Score for RandomForest for K = ',number,'is:',accuracy_score(labelsTest,prediction2))

